#!/usr/bin/perl -w
use English; # $MATCH and the like
# generate TeX code from (abbreviated) DATR definitions

my $example = '
# vars a b c
Sample:
== XREF
the path == value
other ==  XREF:<path>
Sample2:
just = another line

Sample3:
the next == datr

\DATRstart{Wort:}
\DATRspecial{\# vars foo bar}
\DATRline{syn cat}{verb}
\DATRline{syn type}{main}
\DATRline{syn form}{present participle}
\DATRline{mor form}{love ing}
\DATRend

';

my $count = 0;
my $last = "";
for my $line (<STDIN>) {
  chomp $line;

  $line =~ s/#/\\#/g;       # escape     #
  $line =~ s/_/\\_/g;       # escape     _
  $line =~ s/\$/\\\$/g;     # escape     $
  $line =~ s/\"</\`\`</g;   # beautify "<
  $line =~ s/>\"/>\'\'/g;   # beautify    >"
  $line =~ s/\s+=/=/g;      # remove space in front of =
  $line =~ s/=\s+/=/g;      # remove space after       =

  if ($line =~ /\w/) {      # non-empty line
    if ($last =~ /\w/) {    # add to the current theory
      if ($line =~ /=+/) {  # a line with at least one =
        if ($MATCH eq "==") {
          print "\\DATRline\{$PREMATCH\}\{$POSTMATCH\}\\\\\n";
        } else {
          print "\\DATRlineb\{$PREMATCH\}\{$POSTMATCH\}\\\\\n";
        }
      } else {              # a free-form line
        print "\\DATRspecial\{$line\}\\\\\n";
      }
    } else {                # start a new DATR theory
      if ($count != 0) { print "\\DATRend\n\\SldOff\n\n"; }
      print "\\SldOn\{TITEL\}\n\\DATRstart\{$line\}\n";
      $count++;
    }
  } else {
    # print "%\n";          # empty line
  }
  $last = $line;
}
if ($count>0) { print "\\DATRend\n\\SldOff\n\n"; }

